#include <v_lib.h>

vec_t alpha = 0.5f;

/*
 * This function will be passed later to vglDrawToMetafile(),
 * so we need to declare it as 'V_CALL'
 */
void V_CALL draw_scene(void *param)
{
    vglSelectFont(param);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-1,1,-1,1,-1,1);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glDisable(GL_DEPTH_TEST);
    glTranslatef(-1,1,0);
    glScalef(.25f,.3f,.3f);
    glTranslatef(0,-1,0);
    glClearColor(0,0,0,1);
    glClear(GL_COLOR_BUFFER_BIT);
    glColor4f(0,1,1,alpha);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glEnable(GL_LINE_SMOOTH);
    glLineWidth(2.8f);
    /* vglPutsKoi8r("pRIWET !\n"); */
    vglPuts(" !\n\n");
    vglPuts("1234567890");
    vglSelectFont(NULL);
}

int main()
{
    vhandle_t font;
    logStartConsoleLog();
    logUpperLevel(LOG_TRACE);
    font=vglLoadBGIFontEx("../../../media/bgi-fonts/cyrgoth.chr",false);
    if(font)
    {
        input_record_t r;
        vglCreateWindow("Stroke font demo",0,0,320,240);
        /* Animate text */
        do
        {
            while(!vglPending())
            {
                draw_scene(font);
                vglSwapBuffers();
                timeDelay(10);
                alpha += 0.01f;
                if(alpha >= 1.0f)
                    alpha = 0.5f;
            }
            vglNextEvent(&r);
        } while(r.event!=ev_key_down);
        vglDrawToMetafile("out.wmf",100,100,draw_scene,font);
#ifdef  __WIN32__
        /* Draw text to the system clipboard */
        vglDrawToMetafile("//./clipboard",100,100,draw_scene,font);
#endif  /* __WIN32__ */
        /*
         * Note: fonts are reference-counted, so we can safe
         * call vglDestroyFont() befofe vglDestroyWindow().
         */
        vglDestroyFont(font);
        vglDestroyWindow(vglGetCurrentWindow());
    }
    else
    	conlPuts(LOG_ERROR,"Error loading BGI font\n");
    memPrintStats();
    return 0;
}
